/*
   Sequential search for "aardvark" in one file called "data".

   This version does file I/O using a Scanner wrapped around
   a BufferedInputStream wrapped around a FileInputStream.
*/

import java.time.Instant;
import java.time.Duration;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.BufferedInputStream;
import java.util.Scanner;

public class SearchSequential_2a_File
{
   private static final int BUFFERSIZE = 16 * 8192;

   public static void main(String[] args) throws IOException, FileNotFoundException
   {
      // Open the file.
      BufferedInputStream bis = new BufferedInputStream(
                                new FileInputStream("data"), BUFFERSIZE);
      Scanner scanner = new Scanner(bis);

      SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");

      System.out.println(ft.format(new Date()) + " SearchSequential_2a_File");
      Instant start = Instant.now();
      int lineNumber = 0;

      while ( scanner.hasNextLine() ) // this blocks
      {
         ++lineNumber;
         String oneLine = scanner.nextLine();
         byte[] c = oneLine.getBytes("US-ASCII");
         for (int i = 0; i < c.length - 8; i++)
         {
            if ( 'a' == c[i]
              && 'a' == c[i+1]
              && 'r' == c[i+2]
              && 'd' == c[i+3]
              && 'v' == c[i+4]
              && 'a' == c[i+5]
              && 'r' == c[i+6]
              && 'k' == c[i+7] )
            {
               System.out.println(ft.format(new Date()) + " " + lineNumber);
            }
         }
      }
      Instant stop = Instant.now();
      System.out.println(ft.format(new Date()));
      long time = Duration.between(start, stop).toMillis();
      System.out.println("elapsed time: " + time + "ms");
      bis.close();
   }
}
